drm/nouveau: consume the return of large GSP message
[drm/drm-misc.git] / tools / perf / tests / shell / test_data_symbol.sh
blobc86da02350596b35d0e300610686235a4378cd9c
1 #!/bin/bash
2 # Test data symbol (exclusive)
4 # SPDX-License-Identifier: GPL-2.0
5 # Leo Yan <leo.yan@linaro.org>, 2022
7 shelldir=$(dirname "$0")
8 # shellcheck source=lib/waiting.sh
9 . "${shelldir}"/lib/waiting.sh
11 # shellcheck source=lib/perf_has_symbol.sh
12 . "${shelldir}"/lib/perf_has_symbol.sh
14 skip_if_no_mem_event() {
15 perf mem record -e list 2>&1 | grep -E -q 'available' && return 0
16 return 2
19 skip_if_no_mem_event || exit 2
21 skip_test_missing_symbol buf1
23 TEST_PROGRAM="perf test -w datasym"
24 PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
25 ERR_FILE=$(mktemp /tmp/__perf_test.stderr.XXXXX)
27 check_result() {
28 # The memory report format is as below:
29 # 99.92% ... [.] buf1+0x38
30 result=$(perf mem report -i ${PERF_DATA} -s symbol_daddr -q 2>&1 |
31 awk '/buf1/ { print $4 }')
33 # Testing is failed if has no any sample for "buf1"
34 [ -z "$result" ] && return 1
36 while IFS= read -r line; do
37 # The "data1" and "data2" fields in structure "buf1" have
38 # offset "0x0" and "0x38", returns failure if detect any
39 # other offset value.
40 if [ "$line" != "buf1+0x0" ] && [ "$line" != "buf1+0x38" ]; then
41 return 1
43 done <<< "$result"
45 return 0
48 cleanup_files()
50 echo "Cleaning up files..."
51 rm -f ${PERF_DATA}
54 trap cleanup_files exit term int
56 echo "Recording workload..."
58 # perf mem/c2c internally uses IBS PMU on AMD CPU which doesn't support
59 # user/kernel filtering and per-process monitoring, spin program on
60 # specific CPU and test in per-CPU mode.
61 is_amd=$(grep -E -c 'vendor_id.*AuthenticAMD' /proc/cpuinfo)
62 if (($is_amd >= 1)); then
63 perf mem record -vvv -o ${PERF_DATA} -C 0 -- taskset -c 0 $TEST_PROGRAM 2>"${ERR_FILE}" &
64 else
65 perf mem record -vvv --all-user -o ${PERF_DATA} -- $TEST_PROGRAM 2>"${ERR_FILE}" &
68 PERFPID=$!
70 wait_for_perf_to_start ${PERFPID} "${ERR_FILE}"
72 sleep 1
74 kill $PERFPID
75 wait $PERFPID
77 check_result
78 exit $?